/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include "loadicon.h"
#include "iwc.h"
#include "color.h"
#include "pixmap.h"
#include "global.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


void loadicon(Pixmap *backgroundpixmap,Pixmap *shapepixmap,char *iconfile,int *isxvpic,GC gc)
{
  FILE *ficon;
  char line[90];
  static unsigned long *xvpixels;
  static int buildcolormap=True;
  int a,b,width,height,x,y;
  *backgroundpixmap=0;
  *shapepixmap=0;
  *isxvpic=False;
  GetIconPixmap(iconfile,backgroundpixmap,shapepixmap);
  if (*backgroundpixmap==0 && (ficon=fopen(iconfile,"r"))!=NULL) {
    a=fgetc(ficon);
    b=fgetc(ficon);
    if (a==80 && b==55) {
      *isxvpic=True;
      do {
        fscanf(ficon,"%s",line);
      } while(strcmp("#END_OF_COMMENTS",line)!=0);
      fscanf(ficon,"%d %d %d",&width,&height,&a);
      fgetc(ficon);
      *backgroundpixmap=XCreatePixmap(GetDisplay(),GetWindow(),width,height,
				      XDefaultDepth(GetDisplay(),0));
      if (buildcolormap==True) {
        xvpixels=GetXVColors();
	buildcolormap=False;
      }
      for (y=0;y<height;y++)
	for (x=0;x<width;x++) {
	  a=fgetc(ficon); 
	  XSetForeground(GetDisplay(),gc,xvpixels[a]);
	  XDrawPoint(GetDisplay(),*backgroundpixmap,gc,x,y);
	}
    } else {
      LoadPixmap(iconfile,backgroundpixmap,shapepixmap);
      if (*backgroundpixmap!=None) 
	SetIconPixmap(iconfile,*backgroundpixmap,*shapepixmap);
    }
    fclose(ficon);
  }
}




